# Copyright dr. ir. R.J.F. Bijster, 2022

import Simulation
import numpy as np
from matplotlib import pyplot as plt

iterations = 100

advantage = []
times_city = []
times_pedelec = []
for i in range(iterations):
    print(f'{i+1} out of {iterations} ...')
    adv, time_city, time_pedelec = Simulation.Run()
    advantage.append(adv)
    times_city.append(time_city)
    times_pedelec.append(time_pedelec)

mean_advantage = np.mean(advantage)
std_advantage = np.std(advantage)
min_advantage = min(advantage)
max_advantage = max(advantage)

print('='*100)
print(f'Potential time advantage: ({mean_advantage:.1f} +- {std_advantage/np.sqrt(iterations):.1f}) min')
print(f'Extremes: [{min_advantage:.1f}, {max_advantage:.1f}] min')

print(f'City bike: [{min(times_city):.1f}, {max(times_city):.1f}], mean: {np.mean(times_city):.1f} min')
print(f'Pedelec: [{min(times_pedelec):.1f}, {max(times_pedelec):.1f}], mean: {np.mean(times_pedelec):.1f} min')
print('='*100)

# the histogram of the data
n, bins, patches = plt.hist(times_city, 10, density=True, facecolor='g', alpha=0.75, label='City bicycle')
n, bins, patches = plt.hist(times_pedelec, 10, density=True, facecolor='r', alpha=0.75, label='Pedelec')

plt.xlabel('Travel time (min)')
plt.ylabel('Probability')
# plt.text(60, .025, r'$\mu=100,\ \sigma=15$')
# plt.xlim(40, 160)
# plt.ylim(0, 0.03)
plt.legend()
plt.grid(True)
plt.show()